<?php
/**
 * stanislav.elbl, 23.09.2021 13:42
 */

namespace Ron\DB;

interface SqlDialect
{
    /**
     * Vraci retezec identifikujici databazi
     * @return string
     */
    public function getDbType();


    public function getPdoParameterLobOptions();

    /**
     * Vraci SQL vyraz pro zjisteni roku ze zadaneho podvyrazu
     * @param $text
     * @return mixed
     */
    public function extractYearSQL($text);


    /**
     * Prevede hodnotu datoveho pole nacteneho z databaze na timestamp
     * @param mixed $data
     * @return int|null
     */
    public function dataToTimestamp($data);


    /**
     * Vraci SQL konstantu pro zadany cas (unix timestamp)
     * @param int $timestamp
     * @return string
     */
    public function timestampToSQL($timestamp);


    /**
     * Vraci SQL konstantu pro zadany datum (unix timestamp) - cas ignoruje
     * @param int $timestamp
     * @return string
     */
    public function dateToSQL($timestamp);


    /**
     * Vraci SQL konstantu pro zadany cas (unix timestamp) bez datumu
     * @param int $timestamp
     * @return string
     */
    public function timeToSQL($timestamp);


    /**
     * Vraci SQL konstantu pro vlozeni binarnich dat
     * @param $text
     * @return mixed
     */
    public function stringToBinarySQL($text);
}
